function [qq,qmc] = evalq(betasim,etasim,archsim,betamcmc,etamcmc,archmcmc,etapost,betapostm,betapostchol,archpostm,archpostchol,qnormarch)

MMC=size(archpostchol,3);
L=size(betasim,2);
nst=size(etasim,1);
qmall=zeros(L,MMC);
qqall=zeros(L,MMC);

for l=1:MMC
  
      infcholarch=inv(squeeze(archpostchol(:,:,l))); %sigma^-1=infchol'*infchol
      infcholbeta=inv(squeeze(betapostchol(:,:,l))); %sigma^-1=infchol'*infchol
      
      qmall(:,l) = qmall(:,l) + pmultnormsigchol(betamcmc,squeeze(betapostm(:,l*ones(1,L))),infcholbeta)';
      qmall(:,l) = qmall(:,l) + pmultnormsigchol(archmcmc,squeeze(archpostm(:,l*ones(1,L))),infcholarch)'-qnormarch(l);
      if nst>1
      qmall(:,l) = qmall(:,l) + squeeze(dirichlog(etamcmc,etapost(:,:,l*ones(1,L))));
      end
      
      qqall(:,l) = qqall(:,l) + pmultnormsigchol(betasim,squeeze(betapostm(:,l*ones(1,L))),infcholbeta)';
      qqall(:,l) = qqall(:,l) + pmultnormsigchol(archsim,squeeze(archpostm(:,l*ones(1,L))),infcholarch)'-qnormarch(l);
      if nst>1
      qqall(:,l) = qqall(:,l) + squeeze(dirichlog(etasim,etapost(:,:,l*ones(1,L))));
      end
                      
     end

qmax= max(qmall,[],2);
qmc=qmax+log(sum(exp(max(qmall-qmax(:,ones(1,MMC)),-1e15*ones(L,MMC))),2));

qmax= max(qqall,[],2);
qq= qmax+log(sum(exp(max(qqall-qmax(:,ones(1,MMC)),-1e15*ones(L,MMC))),2));

qmc=qmc-log(MMC);
qq=qq-log(MMC);
