       function [alplus,mu, prv, crw] = approxglmgarchinfo(u,alpha,gamma,qu);  
       
              
       m=qu;n=size(u,1);
       pe=size(alpha,1)-qu;
       priorm=zeros(pe,1);
       priorinf=zeros(pe);

       ht=genht(u,alpha,gamma,qu);
       w=1./(ht.^2);
       w=sqrt(0.5*w);


%        spec=garchset;
       spec=garchset('Display','off','R',0,'M',0,'C',0,'P',1,'Q',1,'K',gamma,'ARCH',alpha(1:qu),'GARCH',alpha(qu+1:end),'FixC',1,'FixK',1,'FixARCH',1);
       [Coeff,Errors,LLF,Innovations,Sigma,Summary] = garchfit(spec,u);
%        garchdisp(Coeff,Errors);
       alplus=garchget(Coeff,'GARCH');    
        
%        alplus = lsqnonlin(@minfun,alpha(qu+1:end),[0],[1-sum(alpha(1:qu))],[],u,ht,gamma,alpha(1:qu));

       htplus=genht(u,[alpha(1:qu);alplus],gamma,qu);

       index=[];for i=1:pe;index=[index;pe-i+1:size(htplus,1)-i];end;index=index';
       Xpt=htplus(index);
       Xpt=filter1(Xpt,-alplus);
       
%        Utild=filter1(u.^2,-alplus);
%        onetild=filter1(ones(size(u.^2,1),1),-alplus);
%        
%        index=[];for i=1:pe;index=[index;pe-i+1:size(Utild,1)-i];end;index=index';
%        Ubar=Utild(pe+1:end)-Utild(index)*alplus;
%        
%        nu=size(Ubar,1);
%        Xqt=[onetild(end-nu+1:end) Utild(index)];
%        Wt=Ubar-Xqt*[gamma;alplus];

       Wt=u.^2-htplus;
       
       no=n-(qu+pe+1);
       Yp=Wt(end-no+1:end)+Xpt(end-no+1:end,:)*alplus;
      
       
       Yp=w(end-no+1:end).*Yp;
       Z=w(end-no+1:end,ones(size(Xpt,2),1)).*Xpt(end-no+1:end,:);
       prv=Z'*Z+priorinf;       
       mu=inv(prv)*(Z'*Yp+priorinf*priorm);          
       
       crw=chol(inv(prv))';
