function   [archq, qnormarch] = simqarch(march,archpostm,archpostchol,lm)


archsize=size(archpostm,1);
archq=zeros(archsize,1);
L=max(1000,lm);
archsim = archpostm(:,ones(1,L)) + archpostchol*randn(archsize,L);

%accept q-sample only if thefollowing conditions are fulfilled

cond1=all(archsim>zeros(size(archsim))); % alle positiv
alxiarg=[archsim(1:march,:);archsim(end,:)/2;1-sum(archsim(1:march,:),1)-0.5*archsim(end,:)];
cond2=all(alxiarg<ones(size(alxiarg))); % alle kleiner 1, 1-summe kleiner 1
mindex=and(cond1,cond2);

rn=sum(mindex,2);
qnormarch=rn/L;
L1=rn;

if L1<L 
  %  reject   
  archsim=archsim(:,mindex==ones(1,L));
  L=L1;
end   

if rn > 0
u = simuni(L,lm);  
archq=archsim(:,u);
end