function sst = simstate(fv,trans)
%

[n nst] = size(fv);
rnd = rand(n,1);
sst = zeros(1,n);
p = fv(end,:);
st = sum(cumsum(p) < rnd(n)) + 1;          % sampling
sst(n) = st;

for i = (n-1):-1:1
    p = fv(i,:) .* trans(:,st)';
    p = p / sum(p);
    st = sum(cumsum(p) < rnd(i)) + 1;      % sampling
    sst(i) = st;
end

