function [eta,cnt] = simtransmix(nst,sst,eta,e01,gamma,prgamma1)

etaold=eta;
cnt = countrns(sst,nst) + e01(:,:,end);
eta = gamrnd(cnt,1);
eta = eta ./ (sum(eta,2)*ones(1,nst));

nmix=size(prgamma1,3);

fgamma=prodinvgamlog(gamma(:,ones(1,nmix)),prgamma1)';
fold = fgamma+squeeze(dirichlog(etaold(:,:,ones(1,nmix)),e01));
fnew = fgamma+squeeze(dirichlog(eta(:,:,ones(1,nmix)),e01));

fmax=max(fold);
fold=fmax + log(mean(exp(fold-fmax)));
fmax=max(fnew);
fnew=fmax + log(mean(exp(fnew-fmax)));

qold=dirichlog(etaold,squeeze(e01(:,:,end)));
qnew=dirichlog(eta,squeeze(e01(:,:,end)));

al=exp(fnew-fold+qold-qnew);
acc = min(al,1);
index = rand(1)<=acc;
eta = index*eta+(1-index)*etaold;
