
%Implied moments of the prior
%Draw nut,st,prior parameters
fid=fopen('implmom_vola.out','w');
fprintf(fid,'\t mode \t information \n');
T=1000;
biT=500;
T=T+biT;
L=3000;
K=[4 3 2 1];
Q=[4 3 2];
mq=max(Q);
mk=max(K);
m=0;
lev=1;
rej=0;

file='iniswarch'
randn('state',0);
rand('state',0);
nut=randn(T,L);
ht=zeros(T,L);
htuncsim=zeros(1,L,length(K)*length(Q));
ut=zeros(T+mq,L,length(K)*length(Q));
alphasim=zeros(mq,L,length(K)*length(Q));
xisim=zeros(1,L,length(K)*length(Q));
gammasim=zeros(mk,L,length(K)*length(Q));
etasim=zeros(mk,mk,L,length(K)*length(Q));
etauncsim=zeros(mk,1,L,length(K)*length(Q));

for k=K;
    for q=Q;
        m=m+1;
        load(['iniswarch' num2str(k) num2str(q) num2str(1)])
        %         prgamma=[3 2;3 2; 3 20; 3 15];

        %draw nut,initialize ht,ut
        for l=1:L
            %draw parameters
            al= simalxiprior(alxi0)';
            alxi=[al(1:end-2);al(end-1)*2];
            gamma=(gamrnd(prgamma(:,1),1./(prgamma(:,2)))).^(-1);
            %             gammaold=gamma;
            %             gamma= randn(K,1).*sqrt(prgamma(:,2).^2./(1+prgamma(:,1)).^3)+(prgamma(:,2)./(prgamma(:,1)+1));
            %             if any(gamma<0)
            %                 gamma=gammaold;
            %                 rej=rej+1;
            %             end
            eta=simtransprior(k,e0);

            %compute unconditional ht
            etaunc=(eta')^100*[1 zeros(1,k-1)]';
            htunc= (gamma'*etaunc)./(1-sum(alxi(1:end-1))-alxi(end)/2);
            %draw st
            %             st=simulstprior(T,eta,ones(k,1)./k)';
            %             gamst=[st(:,ones(1,k))==kron(ones(T,1),[1:k])]*gamma;

            %simulate ht
            %             for j=1:T
            %                 ht(j,l)=gamst(j)+ut(mq+j-1:-1:j+(mq-q),l)'.^2*alxi(1:end-1)+(ut(mq+j-1,l)<0)*ut(mq+j-1,l)^2*alxi(end);
            %                 ut(j+mq,l)=sqrt(ht(j,l))*nut(j,l);
            %             end
            alphasim(1:q,l,m)=alxi(1:end-1);
            xisim(1,l,m)=alxi(end);
            gammasim(1:k,l,m)=gamma;
            etasim(1:k,1:k,l,m)=eta;
            etauncsim(1:k,1,l,m)=etaunc;
            htuncsim(1,l,m)=htunc;
        end
        %         ht=ht(biT+1:end,:);
        %         ut=ut(end-size(ht,1)+1:end,:);
        rej=rej/L;
        x=[0:0.5:350];
        f=ksdensity(htuncsim(1,:,m)',x);
        plot(x,f);
        hold on;
%         if m=1;
        text(x(f==max(f)),f(f==max(f)),['(K=' int2str(k) ',q=' int2str(q) ')'],'VerticalAlignment','middle','HorizontalAlignment','left','FontSize',12);
%         elseif m=
        [ve0,de0]=eig((e0./kron(ones(1,k),sum(e0,2)))');
        eta0unc=ve0(:,find(diag(de0)>.99))./sum(ve0(:,find(diag(de0)>.99)));
%         prmode=[prgamma(:,2)./(prgamma(:,1)+1)]'*mean(etauncsim(1:k,1,:,m),3);
%         prinf=([((prgamma(:,1)+1).^3./prgamma(:,2).^2)'].^(-1)*mean(etauncsim(1:k,1,:,m),3).^2)^(-1);
        prmode=[prgamma(:,2)./(prgamma(:,1)+1)]'*eta0unc;
        prinf=([((prgamma(:,1)+1).^3./prgamma(:,2).^2)'].^(-1)*eta0unc.^2)^(-1);
        t=['desw' int2str(k) int2str(q) '\t ' num2str(prmode,'%5.2f') ' \t ' ...
            num2str(prinf,'%5.2f') '\n'];
        fprintf(fid,t);
    end
end


