%function plotprob(prob)

n = size(y,1);
index=[];for i=1:lags;index=[index;lags-i+1:n-i];end;index=index';
Z=[ones(n-lags,1) y(index)];
yt=y(lags+1:end);
[nst mc]=size(gammasim);
m=size(alphasim,1);
stind=kron(ones(1,n),[1:nst]');

n=size(yt,1);
index=[];for i=1:m;index=[index;m-i+1:n-i];end;index=index';


time = 1:n;
c = 2000;
cal = [sort(c-time/260)]';

htsim=zeros(n-m,mc);
for j=1:mc;
       u=yt-Z*betasim(:,j);
       U=u(index).^2;
       dt=(u(m:end-1)<=0.0).*u(m:end-1).^2;
       sst=stind(sstsim(:,:,j));
       htsim(:,j)=(gammasim(sst(m+2:end)',j)+U*alpha+xi*dt)';
end

hmht=[];
kiht=[];
int=100;
for j=1:int:n-m;
[ac, hm, sd, med, ki, ineff] = autocovneu(htsim(j:min(j+int-1,n-m),:)',1);
hmht=[hmht;hm];
kiht=[kiht;ki];
end


%datus=(cal==1970-2/52)+(cal==1971-6/52)+(cal==1974-6/52)+(cal==1975+10/52)+(cal==1980+2/52)+...
%       (cal==1980+27/52)+(cal==1981+27/52)+(cal==1983-6/52);
cal=cal(end-n+m+1:end);
figure(gcf+1); 
plot(cal,sqrt(kiht*252),'k:',cal,sqrt(hmht*252),'k-');
axis([cal(1) cal(end) 5 80]);
xlabel(['SWARCH-L(' int2str(nst) ',' int2str(m) ') model: mean volatility with confidence bands']);

load dax_99.txt;
figure(gcf+1);
plot(cal,sqrt(hmht*252),'k:',cal,dax_99(end-n+m+1:end,2),'k-');
axis([cal(1) cal(end) 5 80]);
xlabel(['SWARCH-L(' int2str(nst) ',' int2str(m) ') model: mean volatility and implied volatility']);

figure(gcf+1);
plot(cal,sqrt(kiht*252)','k:',cal,dax_99(end-n+m+1:end,2),'k-');
axis([cal(1) cal(end) 5 80]);
xlabel(['SWARCH-L(' int2str(nst) ',' int2str(m) ') model: implied volatility with confidence bands']);

% load dax_99.txt;
% figure(2);
% plot(cal,sqrt(kiht*252)','k:',cal,dax_99(end-nt+1:end,2));
% axis([cal(1) cal(end) 5 80]);

